LIBRARY ieee;
USE ieee.std_logic_1164.all;		
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
 
entity rominfr is 	  
  generic ( bits : integer := 10; 
             -- number of bits per ROM word
            addr_bits : integer := 3); 
             -- 2^addr_bits = number of words in ROM 
  port (a   : in std_logic_vector(addr_bits-1 downto 0);   
        do  : out std_logic_vector(bits-1 downto 0));   
end rominfr;   		   

architecture behavioral of rominfr is   
  type rom_type is array (2**addr_bits-1 downto 0) 
    of std_logic_vector (bits-1 downto 0);   
  constant ROM : rom_type :=
  ("0000110001",
   "0100110100",
   "0100110110",
   "0110110000",
   "0000111100",
   "0111110101",
   "0100110100",
   "1111100111");   
begin   
  do <= ROM(conv_integer(unsigned(a)));   
end behavioral; 
