library IEEE;
use IEEE.STD_LOGIC_1164.all;	

library UNISIM;
use UNISIM.vcomponents.all;


entity RAM_16X8_DISTRIBUTED is
	 port(
		 CLK : in STD_LOGIC;
		 WE : in STD_LOGIC;
		 ADDR : in STD_LOGIC_VECTOR(3 downto 0);  
		 DATA_IN : in STD_LOGIC_VECTOR(7 downto 0);
		 DATA_OUT : out STD_LOGIC_VECTOR(7 downto 0)
	     );
end RAM_16X8_DISTRIBUTED;

architecture RAM_16X8_DISTRIBUTED_STRUCTURAL of RAM_16X8_DISTRIBUTED is	
begin
	
	GENERATE_MEMORY:
	for I in 0 to 7 generate
		RAM_16x1_S_1: ram16x1s 
			generic map (INIT => X"0000")
			port map
			  (O => DATA_OUT(I),
	         A0 => ADDR(0),
	 	   A1 => ADDR(1),
	 	   A2 => ADDR(2),
		 	   A3 => ADDR(3),
		 	   D => DATA_IN(I),
		 	   WCLK => CLK,
		       WE => WE
		  );	
	end generate;
	 
end RAM_16X8_DISTRIBUTED_STRUCTURAL;
